package com.qihoo360.apullsdk.apull.view.impl

import android.content.Context
import android.view.View
import com.qihoo360.apullsdk.R
import com.qihoo360.apullsdk.apull.protocol.ApullReportManager
import com.qihoo360.apullsdk.apull.protocol.model.ApullTemplateBase
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullActivity
import com.qihoo360.apullsdk.apull.protocol.model.impl.activity.ApullActivityItem
import com.qihoo360.apullsdk.apull.view.ApullContainerBase
import com.qihoo360.apullsdk.apull.view.utils.ApullCmdHandle
import com.qihoo360.apullsdk.export.splash.SplashUtil
import com.qihoo360.apullsdk.support.imageconfig.ImageDownloaderConfig
import com.qihoo360.apullsdk.support.imageconfig.ImageLoaderWrapper
import com.qihoo360.mobilesafe.stat.QHReportClient
import com.qihoo360.mobilesafe.stat.QHReportEvent
import kotlinx.android.synthetic.main.apullsdk_container_activity_prendant_1511.view.*

class ContainerApullActivity1511(context: Context?, template: ApullTemplateBase?) : ApullContainerBase(context, template) {

    private var templateApullActivity: TemplateApullActivity? = null

    /**
     * 活动素材及配置
     */
    private var mApullActivityItem: ApullActivityItem? = null

    override fun initView(template: ApullTemplateBase?) {
        inflate(context, R.layout.apullsdk_container_activity_prendant_1511,this)
    }

    override fun updateView(template: ApullTemplateBase?) {
        if (template !is TemplateApullActivity || template === templateApullActivity) {
            return
        }
        visibility = View.VISIBLE
        templateApullActivity = template
        if (templateApullActivity?.activity_list == null && templateApullActivity?.activity_list?.size == 0) {
            return
        }
        mApullActivityItem = templateApullActivity?.defaultItem
        updateImage()
        addClickListener()
        ApullReportManager.reportApullSspActivityPv(context, templateApullActivity)
        SplashUtil.addFrequency(templateApullActivity)
    }

    private fun addClickListener() {
        this.setOnClickListener {
            visibility = View.GONE
            SplashUtil.addFrequency(templateApullActivity, 100)
            ApullCmdHandle.applyCmd(context, mApullActivityItem?.material_object?.get(0)?.jumpData, templateApullActivity)

            QHReportClient.reportCountEvent(QHReportEvent.CHARGESCREEN_1000_13, 1)
            ApullReportManager.reportApullSspActivityClick(context, templateApullActivity)
        }
    }


    private fun updateImage() {
        mImageView?.let {
            val imgAUrl = mApullActivityItem?.material_object?.get(index = 0)?.url
            ImageLoaderWrapper.getInstance().displayImage(imgAUrl, it,
                    ImageDownloaderConfig.getDefaultLargeIconOptions(context))
        }
    }

    override fun onThemeChanged() {
    }

    override fun onImageEnableChange(enable: Boolean) {

    }

    override fun getTemplate(): TemplateApullActivity?{
        return templateApullActivity
    }
}