package com.qihoo360.apullsdk.apull.view.impl

import android.content.Context
import android.graphics.Color
import android.text.TextUtils
import android.view.View
import com.qihoo360.apullsdk.R
import com.qihoo360.apullsdk.apull.ApullConst
import com.qihoo360.apullsdk.apull.control.sync.DownloadSatusManager
import com.qihoo360.apullsdk.apull.protocol.ApullReportManager
import com.qihoo360.apullsdk.apull.protocol.model.ApullTemplateBase
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullTouTiao
import com.qihoo360.apullsdk.apull.protocol.network.report.ReportNetworkTouTiao
import com.qihoo360.apullsdk.export.ApullRewardVideoInterface
import com.qihoo360.apullsdk.export.ApullRewardVideoInterface.Companion.template2Json
import com.qihoo360.apullsdk.support.cache.ApullTemplateCacheUtil
import com.qihoo360.apullsdk.support.imageconfig.ImageDownloaderConfig
import com.qihoo360.apullsdk.support.imageconfig.ImageLoaderWrapper
import com.qihoo360.apullsdk.utils.BitmapUtil
import com.qihoo360.apullsdk.utils.DensityUtil
import com.qihoo360.mobilesafe.support.log.Logger
import kotlinx.android.synthetic.main.apullsdk_container_apull_reward_video_bottom.view.*

class ContainerApullToutiao2607VideoBottom : ContainerApullTouTiaoBase{

     var mApullRewardVideoInterface : ApullRewardVideoInterface

    constructor(context: Context?, template: ApullTemplateBase?,apullRewardVideoInterface: ApullRewardVideoInterface) : super(context, template){
        this.mApullRewardVideoInterface = apullRewardVideoInterface
    }

    override fun initView(template: ApullTemplateBase?) {
       inflate(context, R.layout.apullsdk_container_apull_reward_video_bottom,this)
        DownloadSatusManager.register(this)
    }

    override fun updateView(template: ApullTemplateBase?) {
        template?.apply {
            if(template is TemplateApullTouTiao && template != mTemplateApullTouTiao){
                visibility  = View.VISIBLE
                mTemplateApullTouTiao = template
                apullTouTiaoItem = mTemplateApullTouTiao.defaultItem

                mAppProgressBottom.setTextColor(resources.getColor(R.color.apullsdk_common_font_color_7))
                var drawable = BitmapUtil.createSolidDrawable(context, DensityUtil.dip2px(context, 4.0f),
                       0, Color.parseColor("#12CC72"), false)
                mAppProgressBottom.setBackgroundDrawable(drawable)
                drawable = BitmapUtil.createSolidDrawable(context, DensityUtil.dip2px(context, 4.0f),
                        0,resources.getColor(R.color.apullsdk_common_bg_green_v8), true)
                mAppProgressBottom.progressDrawable = drawable
                mAppProgressBottom.setTextDimen(DensityUtil.dip2px(context, 12.0f).toFloat())

                updateText()
                updateImage()
                addClickListener()
            }
        }

    }

    private fun addClickListener() {
        setOnClickListener {
            if(mTemplateApullTouTiao?.click_reported == false){
                mApullRewardVideoInterface.onClick2Download(template2Json(mTemplateApullTouTiao,this@ContainerApullToutiao2607VideoBottom.context))
            }
            handleDownLoadBtnClick()
        }
    }

    private fun updateImage() {
        mAppIconBottom?.let {
            var url = apullTouTiaoItem?.icon
            if(url.isNullOrEmpty()){
                url = apullTouTiaoItem?.image?.url
            }
            ImageLoaderWrapper.getInstance().displayImage(url, it,
                    ImageDownloaderConfig.getDefaultLargeIconOptions(context), template?.rootScene?:0,
                    template?.rootSubscene?:0)
        }
    }

    private fun updateText() {
        mAppTitleBottom?.text = apullTouTiaoItem?.appNameOrTitle
        mAppDescBottom?.text = apullTouTiaoItem?.titleOrDesc
        updateDownloadProgress(mAppProgressBottom)
    }

    override fun onImageEnableChange(enable: Boolean) {
        updateImage()
    }

    override fun getTemplate(): ApullTemplateBase? {
        return mTemplateApullTouTiao
    }

    override fun onThemeChanged() {
    }

    override fun onApkInstalled(downloadid: String, iType: Int) {
        if (!TextUtils.isEmpty(downloadid) && downloadid == mTemplateApullTouTiao?.downloadid) {
            apullTouTiaoItem?.status = ApullConst.STATUS_TYPE_INSTALL_FINISHED
            apullTouTiaoItem?.iType = iType
            if (mTemplateApullTouTiao?.installed_reported == false) {
                mTemplateApullTouTiao?.installed_reported = true
                ApullReportManager.reportApullTouTiao(context, mTemplateApullTouTiao, ReportNetworkTouTiao.REPORTTYPE.INSTALL_FINISH, 0)
                ApullReportManager.reportApullSspTouTiaoInstalled(context, mTemplateApullTouTiao)
                mApullRewardVideoInterface.onApkInstalled(template2Json(mTemplateApullTouTiao,this@ContainerApullToutiao2607VideoBottom.context))
                ApullTemplateCacheUtil.refresh(mTemplateApullTouTiao)
            }
            updateDownloadStatus()
            if (!TextUtils.isEmpty(apullTouTiaoItem?.auto_extra_info_ui) && apullTouTiaoItem?.auto_opened_in_ui == false) {
                // 刷新状态
                apullTouTiaoItem.auto_opened_in_ui = true
                ApullTemplateCacheUtil.refresh(mTemplateApullTouTiao)
                openApp(true)
            }
            Logger.d(TAG, "onApkInstalled downloadid:$downloadid")
        }
    }

    override fun updateDownloadStatus() {
        mHandler.post{
            updateText()
        }
    }


}