package com.qihoo360.mobilesafe.reward.ui.page.dialog

import android.app.Activity
import android.graphics.Color
import android.text.TextUtils
import com.qihoo360.apullsdk.apull.ApullConst
import com.qihoo360.apullsdk.apull.protocol.model.impl.app.ApullAppItem
import com.qihoo360.apullsdk.apull.protocol.model.impl.gdt.ApullGdtItem
import com.qihoo360.apullsdk.apull.protocol.model.impl.mv.ApullMvItem
import com.qihoo360.apullsdk.apull.view.utils.ApullTextPatchUtil
import com.qihoo360.apullsdk.utils.BitmapUtil
import com.qihoo360.apullsdk.utils.DensityUtil
import com.qihoo360.mobilesafe.extension.tryCatch
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.data.ApullItemWrapper
import com.qihoo360.mobilesafe.reward.data.RewardUtils
import kotlinx.android.synthetic.main.dialog_reward_download_hour.*

class RewardDownloadHourDialog(context: Activity, apullItemWrapper: ApullItemWrapper?, mDownloadListener: DownloadListener?) :RewardDownloadDialog(context,apullItemWrapper,mDownloadListener) {

    override  fun  setLayoutId() :Int {
        return R.layout.dialog_reward_download_hour
    }

    override fun handleNoReward(){
        tryCatch {
            if(mRewardType == RewardUtils.REWARD_TYPE_APP){
                handleAppClick()
                if(openAppShouldCloseDialog || mCommitTimeOut){
                    if((mApullItemWrapper?.getAppItemFormType() == 0
                    && mApullItemWrapper?.getDownloadStatus() == ApullConst.STATUS_TYPE_INSTALL_FINISHED)
                            || mApullItemWrapper?.isHourOpenType() == true) {
                        dismiss()
                        showFailRewardDialog()
                    }
                }
            }

        }
    }

    override fun initProgressBtn() {
        //super.initProgressBtn()
        // 初始化下载progress
        mDownloadBtn?.setTextDimenSp(19)
        mDownloadBtn?.setTextColor(Color.parseColor("#db2a38"))
        val drawable = BitmapUtil.createSolidDrawable(context, DensityUtil.dip2px(context, RADIUS_DP),
                0, Color.parseColor("#66ffa200"), true, 0f)
        mDownloadBtn.progressDrawable = drawable
        setAppName()
    }

    private fun setAppName() {
        when(mApullItemWrapper?.getProtocolType()){
            ApullItemWrapper.APP ->{
                mDownloadName?.text = (mApullItemWrapper?.getDefaultItem(false) as? ApullAppItem)?.app_name
            }
        }
    }

    override fun updateButtonStyleStateOpen(){
    }

    override fun updateStatus(apullItemWrapper: ApullItemWrapper?) {
        mHandler.post{
            if (mApullItemWrapper?.equalsUniqueId(apullItemWrapper) == true) {
                mApullItemWrapper = apullItemWrapper
                if (apullItemWrapper?.getAppItemFormType() == 1) {
                    if (apullItemWrapper.getProtocolType() == ApullItemWrapper.APP) {
                        val item = apullItemWrapper.getDefaultItem(false) as? ApullAppItem
                        if (!TextUtils.isEmpty(item?.button_text)) {
                            mDownloadBtn.setText(ApullTextPatchUtil.getFormatText(context, item?.button_text, item?.button_text_patch).toString(), 0)
                        } else {
                            mDownloadBtn.setText(context.resources.getString(R.string.hongbao_open_h5), 0)
                        }
                    } else {
                        mDownloadBtn.setText(context.resources.getString(R.string.hongbao_open_h5), 0)
                    }
                    return@post
                }
            }

            super.updateStatus(apullItemWrapper)
        }

    }
}